'use strict';

var querystring = require('querystring');

module.exports = function (form) {
  return function (_ref) {
    var options = _ref.options,
        headers = _ref.options.headers;


    form = typeof form === 'object' ? querystring.stringify(JSON.parse(JSON.stringify(form))) : form || '';

    var header = Object.keys(headers).find(function (name) {
      return name.toLowerCase() === 'content-type';
    });

    if (!header) {
      headers['content-type'] = 'application/x-www-form-urlencoded';
    }

    return { options, body: rfc3986(form) };
  };
};

var rfc3986 = function rfc3986(str) {
  return str.replace(/[!'()*]/g, function (c) {
    return '%' + c.charCodeAt(0).toString(16).toUpperCase();
  });
};