'use strict';

module.exports = function () {
  return function (_ref) {
    var options = _ref.options,
        headers = _ref.options.headers,
        body = _ref.body;


    var encoding = Object.keys(headers).find(function (name) {
      return name.toLowerCase() === 'transfer-encoding';
    });

    var length = Object.keys(headers).find(function (name) {
      return name.toLowerCase() === 'content-length';
    });

    if (headers[encoding] === 'chunked' || headers[length]) {
      return { options, body };
    }

    if (typeof body === 'string') {
      headers['content-length'] = Buffer.byteLength(body);
    } else if (body instanceof Buffer) {
      headers['content-length'] = body.length;
    }

    return { options, body };
  };
};